# ifndef __ATOMTYPES_H__
# define __ATOMTYPES_H__

#include "MoreExtraAtomRecord.h"

#ifdef __cplusplus
extern "C" {
#endif

# define MAX_RANGES 10
# define MAX_ATOM_TYPES 500
# define ATI_INFINITY 99.99

typedef struct {
  char yh[10];
  char chc[10];
  char flag;
  Statistic 
    CC,
    S[MAX_RANGES], V[MAX_RANGES], dV[MAX_RANGES];
} AtomTypeInfo ;

typedef struct {
  char resnam[MAX_ATOM_TYPES][5];
  char atnam[MAX_ATOM_TYPES][5];
  AtomTypeInfo * ati[MAX_ATOM_TYPES];
} LookupTable ;

AtomTypeInfo * Lookup_ATI
(atom_record * atom, AtomTypeInfo * ati, LookupTable * Lookup);

void PrintLookupTable(LookupTable * Lookup);

AtomTypeInfo * InitAtomTypeInfo(AtomTypeInfo * a);

AtomTypeInfo * ReadAtomTypeInfo 
(char * TypesTable, StringIndex ** ASI);

LookupTable * ReadLookupTable
(char * TypesTable, AtomTypeInfo *ati, StringIndex * SI);

void Lookup_TypTblInfo_PutInFile
(char * TypesTable, file_records * f, LargeExtraAtomRecord ** E);

#ifdef __cplusplus
}
#endif
# endif /* !__ATOMTYPES_H__ */


