#include "util.h"
#include "pdb.h"
#include "MoreExtraAtomRecord.h"

/*
   The function Find_FracSurf_ForFile
   calculates the fractional surface for a file_record f. 

   Input: 
   
   probe       = probe radius 
   FracThresh  = FracSurf threshold between ridge and groove 
                 (usually 0.4)
   SurfThresh  = Surface area threshold between buried
                 and surface (usually 0)

   Output:

   The atom_records in f are set thus:

   v[4] = occ     = -1, not calculated; 
                     1, buried;
                     2, groove;
		     3, exposed.
   v[5] = b       = FracSurf = GXG_ASA / ASA .
   v[6] = surface = GXG_ASA or -2 if not calculated .
   v[7] = volume  = ASA 
*/


void Find_FracSurf_ForFile
(file_records * f, double probe, double FracThresh, double SurfThresh)
;



