# include "ModifiedVolume.h"

void NPrintVolumeParameters(void)
{
  STDERR("PrintVolumeParameters():");
  fprintf(stderr,"the_method= %1d  volume_max_distance= %7.4f distance_check= %7.4f\n",
	 the_method,volume_max_distance,distance_check);
  fprintf(stderr,"vertices_count= %4d plot_file= %d\n",
	  vertices_count,(int) plot_file);
}
  

/* [ 1 ] called 1st .

   Sets up the neighbor calculation and calculates the volume of a
   whole file . */

void Simple_Calculate_Volumes 
(file_records *file, int TheMethod, double VolMaxDist, double DistCheck)
{
  if (distance_check < 0.0)
    distance_check = 8.0 ;  /* This variable is defined in neibour-cube.c */
  the_method = TheMethod ;
  volume_max_distance = VolMaxDist;
  distance_check = DistCheck ;
  setup_file_records (file , 0.0,1) ; /* Used to set up the cube. */
  setup_minmax_xyzr(file,1) ; /* Used to set up the cube. */
  setup_neibouring_cube(file, distance_check) ;
  NPrintVolumeParameters();
  traverse_file_atom_records (file, 
			      call_with_neibours, calculate_atom_volume);
}

